# Copyright (c) 2000-2005, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}
%define with_java5 %{?_with_java5:1}%{!?_with_java5:%{?_without_java5:0}%{!?_without_java5:%{?_java5:%{_java5}}%{!?_java5:0}}}

%define section         free

Summary:        Embeddable LDAP server
Name:           apacheds
Version:        1.0.0
Release:        2jpp
Epoch:		0
Group:          Applications/Internet
License:        Apache 2.0 License
URL:            http://directory.apache.org/subprojects/apacheds/
Source0:        %{name}-%{version}.tar.gz
# svn export http://svn.apache.org/repos/asf/directory/releases/apacheds/1.0.0 apacheds-1.0.0

Source1:        directory-pom-1.0.4.xml
Source2:        %{name}-jpp-depmap.xml
Source3:        %{name}-settings.xml
Source4:        %{name}.init
Source5:        %{name}.sysconfig
Source6:	%{name}-bootstrapper.properties
Source7:	%{name}-log4j.properties
Source8:	%{name}-server.xml


Patch0:		apacheds-core-plugin-pom_xml.patch
Patch1:		apacheds-core-pom_xml.patch
Patch2:		apacheds-core-unit-pom_xml.patch
Patch3:		apacheds-protocol-shared-pom_xml.patch
Patch4:		apacheds-protocol-ldap-pom_xml.patch
Patch5:		apacheds-kerberos-shared-pom_xml.patch
Patch6:		apacheds-server-main-pom_xml.patch
Patch7:		apacheds-server-jndi-pom_xml.patch
Patch8:		apacheds-server-tools-pom_xml.patch
Patch9:		apacheds-server-unit-pom_xml.patch
Patch10:	apacheds-site_xml.patch
Patch11:	apacheds-server-sar-pom_xml.patch
Patch12:	apacheds-server-ssl-pom_xml.patch

Patch13:	apacheds-jdk14-LdapProtocolProvider.patch
Patch14:	apacheds-jdk14-protocol-ldap-pom_xml.patch
Patch15:	apacheds-jdk14-server-main-pom_xml.patch
Patch16:	apacheds-pom_xml.patch

Vendor:         JPackage Project
Distribution:   JPackage
BuildRequires:	jpackage-utils >= 0:1.7.1
BuildRequires:  maven2 >= 0:2.0.4
BuildRequires:  saxon
BuildRequires:  saxon-scripts
BuildRequires:  junit
%if %{with_java5}
BuildRequires:  java-devel >= 0:1.5
%else
BuildRequires:  java-devel >= 0:1.4.2
BuildRequires:  java-devel < 0:1.5
%endif

BuildRequires:  antlr
BuildRequires:  apacheds-daemon-bootstrappers
BuildRequires:  apacheds-shared-ldap
BuildRequires:  apacheds-shared-asn1
BuildRequires:  apacheds-shared-asn1-codec
BuildRequires:  backport-util-concurrent
%if %{with_java5}
BuildRequires:  bouncycastle-jdk1.5
%else
BuildRequires:  bouncycastle-jdk1.4
%endif
BuildRequires:  excalibur-avalon-logkit
BuildRequires:  jakarta-commons-cli
BuildRequires:  jakarta-commons-collections
BuildRequires:  jakarta-commons-io
BuildRequires:  jakarta-commons-lang
BuildRequires:  jakarta-commons-logging
BuildRequires:  jdbm
BuildRequires:  ldapsdk
BuildRequires:  mina >= 0:1.0.0
%if %{with_java5}
BuildRequires:  mina-filter-ssl >= 0:1.0.0
BuildRequires:	jboss4-system
BuildRequires:	jboss4-jmx
%endif
BuildRequires:  nlog4j
BuildRequires:  plexus-archiver
BuildRequires:  plexus-utils
BuildRequires:  spring-beans
BuildRequires:  spring-context
BuildRequires:  spring-core
BuildRequires:  velocity
%if %{gcj_support}
BuildRequires:          java-gcj-compat-devel
Requires(post):         java-gcj-compat
Requires(postun):       java-gcj-compat
%endif
%if ! %{gcj_support}
BuildArch:      noarch
%endif
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
The Apache Directory Server is an embeddable LDAP server implemented
in pure Java. It has several features that make it unique amoung 
LDAP servers. These features are described below:
* Designed as an LDAP and X.500 experimentation platform. Plugable
  components and subsystems make ApacheDS extremely modular and ideal
  for experiments with various aspects of the LDAP protocol.
* The server's frontend is completely separable from its backend 
  and vice-versa making it very flexible for implementing virtual
  directories, proxy servers and gateways to X.500.
* Several backends can be implemented and plugged into the server's
  partition nexus. The server supports a BTree based partition out of
  the box but any backing store can be used to implement a partition
  so long as it conforms to interfaces.
* The server exposes aspects of administration via a special system
  backend. LDAP can be used to manage these concerns through the 
  system naming context at ou=system.
* Java based triggers and stored procedures are being implemented.
* Both the backend subsystem and the frontend are separable and
  independently embeddable.
* The server contains a server side JNDI LDAP provider as the facade
  for the entire backend subsystem. JNDI operations are directly
  translated by this provider into operations against the nexus and
  the target partitions storing server entries.
* The server will use JNDI as the data access API for stored procedures.
  This will make stored procedures functional within and outside of
  the server without requiring recompilation.
* The server's networking code, MINA, Multipurpose Infrastructure for
  Network Applications was designed for pluggable protocol providers,
  of all sorts and not just LDAP. MINA gives ApacheDS the ability to
  handle large amounts of concurrency.
* The server uses the Snickers tools and APIs for ASN.1 BER encoding
  and decoding. These tools are designed for a very small encoding
  and decoding footprint as well as for use in non-blocking servers.


%package base
Group:          Applications/Internet
Summary:        ApacheDS install base

%description base
%{summary}.

%package core-plugin
Group:          Applications/Internet
Summary:        ApacheDS Core Plugin (Maven 2)
Requires:	%{name}-base = %{epoch}:%{version}-%{release}
Requires:	%{name}-core-shared = %{epoch}:%{version}-%{release}
Requires:	maven2 >= 0:2.0.4
Requires:	antlr
Requires:	excalibur-avalon-logkit
Requires:	jakarta-commons-collections
Requires:	velocity

%description core-plugin
A collection of tools as plugins to manage various tasks
associated with the directory server.

%package core-shared
Group:          Applications/Internet
Summary:        ApacheDS Core Shared
Requires:	%{name}-base = %{epoch}:%{version}-%{release}

%description core-shared
Shared classes between the core plugin and the core to 
prevent cyclic dependencies since the core uses the core
plugin.

%package core
Group:          Applications/Internet
Summary:        ApacheDS Core
Requires:	%{name}-base = %{epoch}:%{version}-%{release}
Requires:	%{name}-core-shared = %{epoch}:%{version}-%{release}
Requires:	jakarta-commons-collections
Requires:	jakarta-commons-lang
Requires:	jdbm
Requires:	nlog4j

%description core
Server's core contains the JNDI provider, interceptors, 
schema, and database subsystems. The core is the heart 
of the server without protocols enabled.

%package core-unit
Group:          Applications/Internet
Summary:        ApacheDS Core Unit
Requires:	%{name}-base = %{epoch}:%{version}-%{release}
Requires:	%{name}-core = %{epoch}:%{version}-%{release}
Requires:	antlr
Requires:	apacheds-shared-asn1
Requires:	jakarta-commons-io
Requires:	junit
Requires:	nlog4j

%description core-unit
Integration and performance tests.

%package kerberos-shared
Group:          Applications/Internet
Summary:        ApacheDS Protocol Kerberos Shared
Requires:	%{name}-base = %{epoch}:%{version}-%{release}
Requires:	%{name}-protocol-shared = %{epoch}:%{version}-%{release}
Requires:	apacheds-shared-asn1
%if %{with_java5}
Requires:  	bouncycastle-jdk1.5
%else
Requires:  	bouncycastle-jdk1.4
%endif
Requires:  	mina >= 0:1.0.0
%if %{with_java5}
Requires:  	mina-filter-ssl >= 0:1.0.0
%endif

%description kerberos-shared
The Kerberos protocol provider for ApacheDS.

%package protocol-changepw
Group:          Applications/Internet
Summary:        ApacheDS Protocol Change Password
Requires:	%{name}-base = %{epoch}:%{version}-%{release}
Requires:	%{name}-kerberos-shared = %{epoch}:%{version}-%{release}
Requires:	nlog4j

%description protocol-changepw
The Change Password protocol provider for ApacheDS.

%package protocol-dhcp
Group:          Applications/Internet
Summary:        ApacheDS Protocol Dhcp
Requires:	%{name}-base = %{epoch}:%{version}-%{release}
Requires:	%{name}-protocol-shared = %{epoch}:%{version}-%{release}
Requires:	mina >= 0:1.0.0
Requires:	nlog4j

%description protocol-dhcp
The DHCP protocol provider for ApacheDS.

%package protocol-dns
Group:          Applications/Internet
Summary:        ApacheDS Protocol Dns
Requires:	%{name}-base = %{epoch}:%{version}-%{release}
Requires:	%{name}-protocol-shared = %{epoch}:%{version}-%{release}
Requires:	mina >= 0:1.0.0
Requires:	nlog4j

%description protocol-dns
The DNS protocol provider for ApacheDS.

%package protocol-kerberos
Group:          Applications/Internet
Summary:        ApacheDS Protocol Kerberos
Requires:	%{name}-base = %{epoch}:%{version}-%{release}
Requires:	%{name}-kerberos-shared = %{epoch}:%{version}-%{release}
Requires:	nlog4j

%description protocol-kerberos
The Kerberos protocol provider for ApacheDS.

%package protocol-ldap
Group:          Applications/Internet
Summary:        ApacheDS Protocol Ldap
Requires:	%{name}-base = %{epoch}:%{version}-%{release}
Requires:	%{name}-core = %{epoch}:%{version}-%{release}
Requires:	apacheds-shared-asn1
Requires:	apacheds-shared-asn1-codec
Requires:	mina >= 0:1.0.0
Requires:	nlog4j

%description protocol-ldap
The LDAPv3 protocol provider for ApacheDS.

%package protocol-ntp
Group:          Applications/Internet
Summary:        ApacheDS Protocol Ntp
Requires:	%{name}-base = %{epoch}:%{version}-%{release}
Requires:	%{name}-protocol-shared = %{epoch}:%{version}-%{release}
Requires:	mina >= 0:1.0.0
Requires:	nlog4j

%description protocol-ntp
The NTP protocol provider for ApacheDS.

%package protocol-shared
Group:          Applications/Internet
Summary:        ApacheDS Protocol Shared
Requires:	%{name}-base = %{epoch}:%{version}-%{release}
Requires:	%{name}-core = %{epoch}:%{version}-%{release}
Requires:	junit
Requires:	nlog4j

%description protocol-shared
Shared library that is used by all protocol providers 
in ApacheDS.

%package sar-plugin
Group:          Applications/Internet
Summary:        ApacheDS Server Sar Maven Plugin
Requires:	%{name}-base = %{epoch}:%{version}-%{release}
Requires:	maven2 >= 0:2.0.4
Requires:	plexus-utils

%description sar-plugin
%{summary}.

%package schema-archetype
Group:          Applications/Internet
Summary:        ApacheDS Schema Archetype
Requires:	%{name}-base = %{epoch}:%{version}-%{release}

%description schema-archetype
%{summary}.

%package server-jndi
Group:          Applications/Internet
Summary:        ApacheDS Server JNDI
Requires:	%{name}-base = %{epoch}:%{version}-%{release}
Requires:	%{name}-core = %{epoch}:%{version}-%{release}
Requires:	%{name}-protocol-changepw = %{epoch}:%{version}-%{release}
Requires:	%{name}-protocol-kerberos = %{epoch}:%{version}-%{release}
Requires:	%{name}-protocol-ldap = %{epoch}:%{version}-%{release}
Requires:	%{name}-protocol-ntp = %{epoch}:%{version}-%{release}
Requires:	backport-util-concurrent
Requires:	nlog4j

%description server-jndi
The JNDI provider which launches the core and associated
network services: Changepw, Kerberos, LDAP, and NTP if
all are configured. By default only LDAP is configured
to startup.

%package server-main
Group:          Applications/Internet
Summary:        ApacheDS Server Main
Requires:	%{name}-base = %{epoch}:%{version}-%{release}
Requires:	%{name}-core = %{epoch}:%{version}-%{release}
Requires:	%{name}-server-jndi = %{epoch}:%{version}-%{release}
Requires:	apacheds-daemon-bootstrappers >= 0:1.0.0
Requires:	jakarta-commons-daemon-jsvc
Requires:	jakarta-commons-logging
Requires:	nlog4j
Requires:	spring-beans
Requires:	spring-context
Requires:	spring-core

%description server-main
%{summary}.

%if %{with_java5}
%package server-sar
Group:          Applications/Internet
Summary:        ApacheDS Server Sar (JBoss 3.x)
Requires:	%{name}-base = %{epoch}:%{version}-%{release}
Requires:	%{name}-server-ssl = %{epoch}:%{version}-%{release}
Requires:	apacheds-daemon-bootstrappers >= 0:1.0.0
Requires:	jakarta-commons-logging
Requires:	jboss4-system
Requires:	jboss4-jmx
Requires:	nlog4j
Requires:	spring-beans
Requires:	spring-context
Requires:	spring-core

%description server-sar
A server archive file for ApacheDS to run within a 
JBoss 3.x instance.

%package server-ssl
Group:          Applications/Internet
Summary:        ApacheDS Server SSL
Requires:	%{name}-base = %{epoch}:%{version}-%{release}
Requires:	%{name}-server-jndi = %{epoch}:%{version}-%{release}
Requires:	java >= 0:1.5
Requires:	nlog4j
Requires:	mina >= 0:1.0.0

%description server-ssl
An SSL support module for LDAPS with ApacheDS.
%endif

%package server-tools
Group:          Applications/Internet
Summary:        ApacheDS Server Tools
Requires:	%{name}-base = %{epoch}:%{version}-%{release}
Requires:	%{name}-server-main = %{epoch}:%{version}-%{release}
Requires:	apacheds-daemon-bootstrappers >= 0:1.0.0
Requires:	jakarta-commons-cli
Requires:	jakarta-commons-lang

%description server-tools
Contained within this executable jar are various 
commandline utilities for ApacheDS.

%package server-unit
Group:          Applications/Internet
Summary:        ApacheDS Server Unit
Requires:	%{name}-base = %{epoch}:%{version}-%{release}
Requires:	%{name}-core-unit = %{epoch}:%{version}-%{release}
Requires:	%{name}-server-jndi = %{epoch}:%{version}-%{release}
Requires:	backport-util-concurrent
Requires:	junit
Requires:	ldapsdk
Requires:	nlog4j

%description server-unit
Unit testing framework for ApacheDS Server JNDI Provider.

%package testcase-archetype
Group:          Applications/Internet
Summary:        ApacheDS Testcase Archetype
Requires:	%{name}-base = %{epoch}:%{version}-%{release}

%description testcase-archetype
%{summary}.

%package javadoc
Group:          Development/Documentation
Summary:        Javadoc for %{name}
Requires(post):   /bin/rm,/bin/ln
Requires(postun): /bin/rm

%description javadoc
%{summary}.

%package manual
Group:          Development/Documentation
Summary:        Documents for %{name}

%description manual
%{summary}.

%prep
rm -rf $RPM_BUILD_ROOT
%setup -q -n %{name}-%{version}

%patch0 -b .sav
%patch1 -b .sav
%patch2 -b .sav
%patch3 -b .sav
%patch4 -b .sav
%patch5 -b .sav
%patch6 -b .sav
%patch7 -b .sav
%patch8 -b .sav
%patch9 -b .sav
%patch10 -b .sav
%patch11 -b .sav
%patch12 -b .sav

%if ! %{with_java5}
# jdk14 related
%patch13 -b .jdk14
%patch14 -b .jdk14
%patch15 -b .jdk14
%patch16 -b .jdk14
%endif

%build
cp %{SOURCE3} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

for p in $(find . -name "*.pom"); do
    pushd $(dirname $p)
    bp=`basename $p`
    cp $bp $bp.orig
    /usr/bin/saxon -o $bp $bp.orig /usr/share/java-utils/xml/maven2jpp-mapdeps.xsl map=%{SOURCE2}
    popd
done

for p in $(find . -name "*pom.xml"); do
    pushd $(dirname $p)
    bp=`basename $p`
    cp $bp $bp.orig
    /usr/bin/saxon -o $bp $bp.orig /usr/share/java-utils/xml/maven2jpp-mapdeps.xsl map=%{SOURCE2}
    popd
done

mkdir -p m2_repo/repository/JPP/maven2/default_poms
cp %{SOURCE1} \
m2_repo/repository/JPP/maven2/default_poms/org.apache.directory-build.pom
cp sar-plugin/pom.xml \
m2_repo/repository/JPP/maven2/default_poms/org.apache.directory.server-apacheds-sar-plugin.pom

mkdir -p m2_repo/repository/JPP/lcrypto-jdk14/131
pushd m2_repo/repository/JPP/lcrypto-jdk14/131
ln -sf $(build-classpath bouncycastle/lcrypto) lcrypto-jdk14-131.jar
popd

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

%if %{with_java5}
export JAVA_HOME=%{_jvmdir}/java-1.5.0
%else
export JAVA_HOME=%{_jvmdir}/java-1.4.2
%endif
MVN=/usr/bin/mvn
export MAVEN_OPTS="-Xmx512m"
export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=`pwd`/m2_repo/repository
#export MAVEN_OPTS="-Dmaven.repo.local=$MAVEN_REPO_LOCAL -Dmaven2.jpp.mode=true -Dmaven.test.failure.ignore=true -Djava.awt.headless=true"
export MAVEN_OPTS="-Dmaven.repo.local=$MAVEN_REPO_LOCAL -Dmaven2.jpp.mode=true -Djava.awt.headless=true -Dintegration"
%if %{with_java5}
pushd sar-plugin
${MVN} -s ${M2SETTINGS} ${MAVEN_OPTS} install
popd
mkdir -p m2_repo/repository/org.apache.directory.server
cp sar-plugin/target/apacheds-sar-plugin-1.0.0.jar \
m2_repo/repository/org.apache.directory.server/apacheds-sar-plugin.jar
%endif
${MVN} -s ${M2SETTINGS} ${MAVEN_OPTS} install
${MVN} -s ${M2SETTINGS} ${MAVEN_OPTS} -N site


%install
rm -rf $RPM_BUILD_ROOT

# system
install -d -m 0755 $RPM_BUILD_ROOT%{_sysconfdir}/rc.d/init.d
install -m 0755 %{SOURCE4} $RPM_BUILD_ROOT%{_sysconfdir}/rc.d/init.d/%{name}
install -d -m 0755 $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig
install -m 0644 %{SOURCE5} $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/%{name}

# home
install -d -m 0755 $RPM_BUILD_ROOT%{_datadir}/%{name}/bin
pushd $RPM_BUILD_ROOT%{_datadir}/%{name}/bin
ln -sf /usr/sbin/jsvc apacheds
ln -sf $(build-classpath apacheds-daemon-bootstrappers) bootstrapper.jar
ln -sf $(build-classpath nlog4j) logger.jar
ln -sf $(build-classpath commons-daemon) daemon.jar
popd
install -d -m 0755 $RPM_BUILD_ROOT%{_datadir}/%{name}/conf
install -m 0755 %{SOURCE6} $RPM_BUILD_ROOT%{_datadir}/%{name}/conf/bootstrapper.properties
install -m 0755 %{SOURCE7} $RPM_BUILD_ROOT%{_datadir}/%{name}/conf/log4j.properties
install -m 0755 %{SOURCE8} $RPM_BUILD_ROOT%{_datadir}/%{name}/conf/server.xml

install -d -m 0755 $RPM_BUILD_ROOT%{_localstatedir}/lib/%{name}/lib/ext
build-jar-repository $RPM_BUILD_ROOT%{_localstatedir}/lib/%{name}/lib \
antlr \
apacheds/core-shared \
apacheds/core \
apacheds/kerberos-shared \
apacheds/protocol-changepw \
apacheds/protocol-kerberos \
apacheds/protocol-ldap \
apacheds/protocol-shared \
apacheds/server-jndi \
apacheds/server-main \
%if %{with_java5}
apacheds/server-ssl \
%endif
apacheds-shared-asn1-codec \
apacheds-shared-asn1 \
apacheds-shared-ldap \
backport-util-concurrent \
bouncycastle/lcrypto \
commons-collections \
commons-logging \
jdbm \
mina/core \
%if %{with_java5}
mina/filter-ssl \
%endif
spring/beans \
spring/context \
spring/core \

install -d -m 0755 $RPM_BUILD_ROOT%{_localstatedir}/%{name}
ln -sf %{_localstatedir}/%{name} $RPM_BUILD_ROOT%{_datadir}/%{name}/var
install -d -m 0755 $RPM_BUILD_ROOT%{_localstatedir}/log/%{name}
ln -sf %{_localstatedir}/log/%{name} $RPM_BUILD_ROOT%{_localstatedir}/%{name}/log
install -d -m 0755 $RPM_BUILD_ROOT%{_localstatedir}/%{name}/run
ln -sf %{_localstatedir}/tmp $RPM_BUILD_ROOT%{_localstatedir}/%{name}/tmp
install -d -m 0755 $RPM_BUILD_ROOT%{_localstatedir}/%{name}/partitions
ln -sf %{_localstatedir}/lib/%{name}/lib $RPM_BUILD_ROOT%{_datadir}/%{name}/lib

# bin
#BUILD/apacheds-1.0.0/schema-archetype/apacheds-schema-archetype.sh
#BUILD/apacheds-1.0.0/server-main/apacheds.sh
#BUILD/apacheds-1.0.0/testcase-archetype/apacheds-testcase-archetype.sh

# jars
install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}/%{name}

install -m 644 core-plugin/target/%{name}-core-plugin-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/core-plugin-%{version}.jar
install -m 644 core-shared/target/%{name}-core-shared-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/core-shared-%{version}.jar
install -m 644 core/target/%{name}-core-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/core-%{version}.jar
install -m 644 core-unit/target/%{name}-core-unit-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/core-unit-%{version}.jar
install -m 644 kerberos-shared/target/%{name}-kerberos-shared-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/kerberos-shared-%{version}.jar
install -m 644 protocol-changepw/target/%{name}-protocol-changepw-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/protocol-changepw-%{version}.jar
install -m 644 protocol-dhcp/target/%{name}-protocol-dhcp-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/protocol-dhcp-%{version}.jar
install -m 644 protocol-dns/target/%{name}-protocol-dns-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/protocol-dns-%{version}.jar
install -m 644 protocol-kerberos/target/%{name}-protocol-kerberos-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/protocol-kerberos-%{version}.jar
install -m 644 protocol-ldap/target/%{name}-protocol-ldap-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/protocol-ldap-%{version}.jar
install -m 644 protocol-ntp/target/%{name}-protocol-ntp-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/protocol-ntp-%{version}.jar
install -m 644 protocol-shared/target/%{name}-protocol-shared-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/protocol-shared-%{version}.jar
install -m 644 sar-plugin/target/%{name}-sar-plugin-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/sar-plugin-%{version}.jar
install -m 644 schema-archetype/target/%{name}-schema-archetype-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/schema-archetype-%{version}.jar
install -m 644 server-jndi/target/%{name}-server-jndi-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/server-jndi-%{version}.jar
install -m 644 server-main/target/%{name}-server-main-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/server-main-%{version}.jar
%if %{with_java5}
install -m 644 server-sar/target/%{name}-server-sar-%{version}.sar $RPM_BUILD_ROOT%{_javadir}/%{name}/server-sar-%{version}.sar
install -m 644 server-ssl/target/%{name}-server-ssl-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/server-ssl-%{version}.jar
%endif
install -m 644 server-tools/target/%{name}-server-tools-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/server-tools-%{version}.jar
install -m 644 server-unit/target/%{name}-server-unit-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/server-unit-%{version}.jar
install -m 644 testcase-archetype/target/%{name}-testcase-archetype-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/testcase-archetype-%{version}.jar

(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# javadoc
install -d -m 0755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/docs/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -sf %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} #ghost
rm -rf target/site/docs/api

# manual
install -d -m 0755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr target/site/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%pre server-main
%{_sbindir}/groupadd apacheds 2> /dev/null || :
%{_sbindir}/useradd -c "ApacheDS" -g apacheds \
    -d %{_datadir}/%{name} apacheds 2> /dev/null || :

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
    rm -f %{_javadocdir}/%{name}
fi

%if %{gcj_support}
%post core-plugin
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun core-plugin
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%post core-shared
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun core-shared
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%post core
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun core
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%post core-unit
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun core-unit
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%post kerberos-shared
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun kerberos-shared
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%post protocol-changepw
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun protocol-changepw
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%post protocol-dhcp
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun protocol-dhcp
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%post protocol-dns
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun protocol-dns
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%post protocol-kerberos
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun protocol-kerberos
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%post protocol-ldap
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun protocol-ldap
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%post protocol-ntp
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun protocol-ntp
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%post protocol-shared
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun protocol-shared
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%post sar-plugin
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun sar-plugin
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%post schema-archetype
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun schema-archetype
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%post server-jndi
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun server-jndi
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%post server-main
# install apacheds (but don't activate)
/sbin/chkconfig --add %{name}
# Create automated links - since all needed extensions may not have been
# installed for this jvm output is muted
# Try to set a sensible jvm
unset JAVA_HOME
[ -r %{_sysconfdir}/sysconfig/%{name} ] && . %{_sysconfdir}/sysconfig/%{name}
[ -z "$JAVA_HOME" ] && [ -r %{_sysconfdir}/java/java.conf ] && \
    . %{_sysconfdir}/java/java.conf
[ -z "$JAVA_HOME" ] && JAVA_HOME=%{_jvmdir}/java
# Remove old automated symlinks
for repository in %{_localstatedir}/lib/%{name}/lib ; do
    find $repository -name '\[*\]*.jar' -not -type d | xargs rm -f
done
build-jar-repository %{_localstatedir}/lib/%{name}/lib \
antlr \
apacheds/core-shared \
apacheds/core \
apacheds/kerberos-shared \
apacheds/protocol-changepw \
apacheds/protocol-kerberos \
apacheds/protocol-ldap \
apacheds/protocol-shared \
apacheds/server-jndi \
apacheds/server-main \
%if %{with_java5}
apacheds/server-ssl \
%endif
apacheds-shared-asn1-codec \
apacheds-shared-asn1 \
apacheds-shared-ldap \
backport-util-concurrent \
bouncycastle/lcrypto \
commons-collections \
commons-logging \
jdbm \
mina/core \
%if %{with_java5}
mina/filter-ssl \
%endif
spring/beans \
spring/context \
spring/core \
2>&1

%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun server-main
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%post server-tools
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun server-tools
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%post server-unit
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun server-unit
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%post testcase-archetype
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun testcase-archetype
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files base
%defattr(0644,root,root,0755)
%dir %{_javadir}/%{name}
%if %{gcj_support}
%attr(-,root,root) %dir %{_libdir}/gcj/%{name}
%endif

%files core-plugin
%defattr(0644,root,root,0755)
%doc core-plugin/LICENSE.txt
%{_javadir}/%{name}/core-plugin*.jar
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/core-plugin-%{version}.jar.*
%endif

%files core-shared
%defattr(0644,root,root,0755)
%doc core-shared/LICENSE.txt
%{_javadir}/%{name}/core-shared*.jar
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/core-shared-%{version}.jar.*
%endif

%files core
%defattr(0644,root,root,0755)
%doc core/LICENSE.txt
%{_javadir}/%{name}/core-%{version}.jar
%{_javadir}/%{name}/core.jar
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/core-%{version}.jar.*
%endif

%files core-unit
%defattr(0644,root,root,0755)
%doc core-unit/LICENSE.txt
%{_javadir}/%{name}/core-unit*.jar
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/core-unit-%{version}.jar.*
%endif

%files kerberos-shared
%defattr(0644,root,root,0755)
%doc kerberos-shared/LICENSE.txt
%{_javadir}/%{name}/kerberos-shared*.jar
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/kerberos-shared-%{version}.jar.*
%endif

%files protocol-changepw
%defattr(0644,root,root,0755)
%doc protocol-changepw/LICENSE.txt
%{_javadir}/%{name}/protocol-changepw*.jar
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/protocol-changepw-%{version}.jar.*
%endif

%files protocol-dhcp
%defattr(0644,root,root,0755)
%doc protocol-dhcp/LICENSE.txt
%{_javadir}/%{name}/protocol-dhcp*.jar
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/protocol-dhcp-%{version}.jar.*
%endif

%files protocol-dns
%defattr(0644,root,root,0755)
%doc protocol-dns/LICENSE.txt
%{_javadir}/%{name}/protocol-dns*.jar
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/protocol-dns-%{version}.jar.*
%endif

%files protocol-kerberos
%defattr(0644,root,root,0755)
%doc protocol-kerberos/LICENSE.txt
%{_javadir}/%{name}/protocol-kerberos*.jar
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/protocol-kerberos-%{version}.jar.*
%endif

%files protocol-ldap
%defattr(0644,root,root,0755)
%doc protocol-ldap/LICENSE.txt
%{_javadir}/%{name}/protocol-ldap*.jar
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/protocol-ldap-%{version}.jar.*
%endif

%files protocol-ntp
%defattr(0644,root,root,0755)
%doc protocol-ntp/LICENSE.txt
%{_javadir}/%{name}/protocol-ntp*.jar
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/protocol-ntp-%{version}.jar.*
%endif

%files protocol-shared
%defattr(0644,root,root,0755)
%doc protocol-shared/LICENSE.txt
%{_javadir}/%{name}/protocol-shared*.jar
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/protocol-shared-%{version}.jar.*
%endif

%files sar-plugin
%defattr(0644,root,root,0755)
%doc sar-plugin/LICENSE.txt
%{_javadir}/%{name}/sar-plugin*.jar
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/sar-plugin-%{version}.jar.*
%endif

%files schema-archetype
%defattr(0644,root,root,0755)
%doc schema-archetype/LICENSE.txt
%{_javadir}/%{name}/schema-archetype*.jar

%files server-jndi
%defattr(0644,root,root,0755)
%doc server-jndi/LICENSE.txt
%{_javadir}/%{name}/server-jndi*.jar
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/server-jndi-%{version}.jar.*
%endif

%files server-main
%defattr(0644,root,root,0755)
%doc server-main/LICENSE.txt
%{_javadir}/%{name}/server-main*.jar
%attr(755,root,root) %{_sysconfdir}/rc.d/init.d/%{name}
%{_sysconfdir}/sysconfig/%{name}
#%attr(-,apacheds,apacheds) %dir %{_datadir}/%{name}
%attr(-,apacheds,apacheds) %{_datadir}/%{name}
#%{_datadir}/%{name}/bin
#%{_datadir}/%{name}/conf
#%{_datadir}/%{name}/lib
#%{_datadir}/%{name}/var
%attr(-,apacheds,apacheds) %{_localstatedir}/%{name}
%attr(-,apacheds,apacheds) %{_localstatedir}/log/%{name}
%attr(-,apacheds,apacheds) %{_localstatedir}/lib/%{name}

%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/server-main-%{version}.jar.*
%endif

%if %{with_java5}
%files server-sar
%defattr(0644,root,root,0755)
%doc server-sar/LICENSE.txt
%{_javadir}/%{name}/server-sar*.sar

%files server-ssl
%defattr(0644,root,root,0755)
%doc server-ssl/LICENSE.txt
%{_javadir}/%{name}/server-ssl*.jar
%endif

%files server-tools
%defattr(0644,root,root,0755)
%doc server-tools/LICENSE.txt
%{_javadir}/%{name}/server-tools*.jar
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/server-tools-%{version}.jar.*
%endif

%files server-unit
%defattr(0644,root,root,0755)
%doc server-unit/LICENSE.txt
%{_javadir}/%{name}/server-unit*.jar
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/server-unit-%{version}.jar.*
%endif

%files testcase-archetype
%defattr(0644,root,root,0755)
%doc testcase-archetype/LICENSE.txt
%{_javadir}/%{name}/testcase-archetype*.jar

%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}/%{name}-%{version}
%ghost %{_javadocdir}/%{name}

%files manual
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}

%changelog
* Fri Nov 17 2006 Ralph Apel <r.apel at r-apel.de> 0:1.0.0-2jpp
- Fix jars included in apacheds-core

* Sat Oct 28 2006 Ralph Apel <r.apel at r-apel.de> 0:1.0.0-1jpp
- First JPackage release.
- Add post/postun Requires for javadoc
- Add gcj_support option
- Add --with java5 option for full build
- Patched server-sar to jboss4
